// $Id: kNNI.h 69 2006-02-11 00:44:22Z jari $

#ifndef _theplu_utility_knni_
#define _theplu_utility_knni_ 

#include <c++_tools/utility/NNI.h>

#include <iostream>
#include <vector>

namespace theplu {
namespace utility {

	///
	/// kNNI is the binary weight implementation of NNI. This follows
	/// the work done by Troyanskaya et al. cited in the NNI document
	/// referred to in the NNI class documentation.
	///
	/// This is a special case of the WeNNI, but is maintained since it
	/// is faster than the more general WeNNI.
	///
	/// @see NNI and WeNNI
	///
	class kNNI : public NNI
	{
	public:
		///
		/// Constructor
		///
		kNNI(const gslapi::matrix& matrix,const gslapi::matrix& weight,
				 const u_int neighbours);

		///
		/// Perform kNNI on data in \a matrix with binary uncertainty
		/// weights in \a weight using \a neighbours for the new impute
		/// value.
		///
		u_int estimate(void);

	private:
		std::vector<u_int> mv_rows_;	// index to rows that have values to estimate
  };

}} // of namespace utility and namespace theplu

#endif
