// $Id: stl_utility.cc 69 2006-02-11 00:44:22Z jari $

#include <c++_tools/utility/stl_utility.h>
#include <c++_tools/utility/utility.h>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>

namespace theplu {
namespace utility {

	
	bool read_to_double(std::istream& is, std::vector<double>& vec)
	{
		vec.resize(0);
		std::vector<std::string> vec_str;
		if (read_to_string(is,vec_str)){
			for (size_t i=0; i<vec_str.size(); i++) {
				if (!is_float(vec_str[i])){
					std::cerr << "Warning: '" << vec_str[i] 
										<< "' is not a number." << std::endl;
				}
				else
					vec.push_back(atof(vec_str[i].c_str()));
			}	
			return true;
		}
		else 
			return false;
	}



	bool read_to_int(std::istream& is, std::vector<int>& vec)
	{
		vec.resize(0);
		std::vector<std::string> vec_str;
		if (read_to_string(is,vec_str)){
			for (size_t i=0; i<vec_str.size(); i++) {
				if (!is_int(vec_str[i])){
					std::cerr << "Warning: '" << vec_str[i] 
										<< "' is not an integer." << std::endl;
				}
				else
					vec.push_back(atoi(vec_str[i].c_str()));
			}
			return true;
		}
		else 
			return false;
	}



	bool read_to_string(std::istream& is, std::vector<std::string>& vec)
	{
		vec.resize(0);
		std::string s;
		if (getline(is, s, '\n')){
			std::istringstream line(s);
			std::string tmp_string;
			while (line >> tmp_string) 
				vec.push_back(tmp_string);
			return true;
		}
		else 
			return false;
	}


}} // end of namespace utility and namespace thep

