// $Id: utility.h 69 2006-02-11 00:44:22Z jari $

#ifndef _theplu_utility_utility_
#define _theplu_utility_utility_ 

///
/// @file utility/utility.h
///
/// Some useful functions are placed here
///

#include <string>

namespace theplu {
namespace utility {


	///
	/// Function return true if string is a number. A number is defined
	/// to start with plus(+), minus(-), deimal point(.), or a
	/// digit(0-9). It must contain at most one decimal point(.). Also
	/// it may contain 'E' or 'e' followed by an integer (see is_int).
	///
	/// @return true if string is a number
	///
	bool is_float(const std::string&);

	///
	/// @return true if every character in string is a digit except the
	/// first one that may be '+' or '-'
	///
	bool is_int(const std::string&);


}} // of namespace utility and namespace theplu

#endif
